# Script Performance #

As with most VFX processes and software, a Gaffer script is subject to performance considerations. Both its node graph stucture and the expressions and statements that go into it can result in undesirably slow evaluation. Since the cause(s) of a slow script might not be immediately apparent, developing a basic understanding of how Gaffer evaluates graphs, as well as the complexity pitfalls users commonly encounter, will help you ensure optimum performance.

<!-- TOC 
    TODO: Multithreading/index.md
    TODO: DeferredExecution/index.md
-->

```eval_rst
.. toctree::
    :titlesonly:
    :maxdepth: 1

    PerformanceBestPractices/index.md
    UsingThePerformanceMonitor/index.md
```
